//#include "Model.h"
#include "Particle.h"
#include <stdlib.h>
#include <GLFW\glfw3.h>

//#include <GL/glut.h>
float lifetime;                       // Lifetime of the particle
float decay;                          // decay speed of the particle
float xpos, ypos, zpos;                 // position of the particle
float xspeed, yspeed, zspeed;           // speed of the particle
bool active;						  // is particle active or not?
float deltaTimeP = 0.0f;

// Constructor for a particle.
void Particle::CreateParticle()
{
	lifetime = 500 - rand() % 1000;
	decay = 1;
	xpos = 0.0f;
	ypos = 0.0f;
	zpos = 0.0f;
	xspeed = (rand() % 1)*deltaTimeP;
	yspeed = (rand() % 1)*deltaTimeP;
	zspeed = (rand() % 1)*deltaTimeP;
	active = true;
}


/*
Evolves the particle parameters over time.
This method changes the vertical and horizontal poition of the particle, its, speed and decay time.
*/
void Particle::EvolveParticle()
{
	lifetime -= decay;
	xpos += (int)rand() % 2 * deltaTimeP;
	ypos += (int)rand() % 2 * deltaTimeP;
	zpos -= (int)rand() % 2 * deltaTimeP;

	xspeed = (rand() % 1)*deltaTimeP;
	yspeed = (rand() % 1)*deltaTimeP;
	zspeed = (rand() % 1)*deltaTimeP;
}



void Particle::SetXPos(float xPos)
{
	xpos = xPos;
}

void Particle::SetYPos(float yPos)
{
	xpos = yPos;
}

void Particle::SetZPos(float zPos)
{
	zpos = zPos;
}

void Particle::SetDeltaTime(float deltaTime) {
	deltaTimeP = deltaTime;
}

void Particle::SetLifeTime() {
	lifetime = 500 - rand() % 1000;
}

void Particle::SetActive() {
	active = true;
}

float Particle::GetXPos()
{
	return xpos;
}

float Particle::GetYPos()
{
	return ypos;
}

float Particle::GetZPos()
{
	return zpos;
}

bool Particle::GetActive() {
	return active;
}

float Particle::GetLifetime() {
	return lifetime;
}